{%- import "src/_utils.j2" as utils with context -%}
{%- import "src/_tree_utils.j2" as tree with context -%}



{%- macro setELSIRoot(globals, uuid)  -%}
  {#- need first to initialise -#}
  {%- do globals.global_ns.dataset_vars.update({ "elsi_names" : [] }) -%}

   {%- do globals.global_ns.dataset_vars.update({ "data_elsi_root" : uuid }) -%}
{%- endmacro -%}







{%- macro setELSIDatasetNames(globals, entity, reply)  -%}
  {{ utils.getDatasetNames(entity, globals.global_ns.dataset_vars.name_list, "ELSI", reply) }}
  {%- set elsi_names = utils.global_ns.var_stack.pop() -%}
  {%- do globals.global_ns.dataset_vars.update({ "elsi_names" : elsi_names }) -%}
{%- endmacro -%}





{%- macro processPersonalData(globals, dmp_being_built, reply, uuid)  -%}
 
  {{ tree.isChildOf(globals, uuid, globals.global_ns.dataset_vars.data_elsi_root) }}
  {%- set answer_correct_item = tree.global_ns.var_stack.pop() -%}
  {%- if answer_correct_item -%}
    {{ utils.getControlledVocabularyTermYNU(reply) }}
    {%- set answer = utils.global_ns.var_stack.pop()  -%}

    {%- set elsi_names = globals.global_ns.dataset_vars.elsi_names -%}
    {%- for name in elsi_names -%}
      {{ utils.getDatasetsFromNames(globals, dmp_being_built, [name]) }}
      {%- set datasets = utils.global_ns.var_stack.pop()  -%}
      {%- for dataset in datasets -%}
        {%- do dataset.update({ "personal_data" : answer }) -%}
      {%- endfor -%}
    {%- endfor -%}
  {%- endif -%}
{%- endmacro -%}



{%- macro processSensitiveData(globals, dmp_being_built, reply, uuid)  -%}

  {{ tree.isChildOf(globals, uuid, globals.global_ns.dataset_vars.data_elsi_root) }}
  {%- set answer_correct_item = tree.global_ns.var_stack.pop() -%}
  {%- if answer_correct_item -%}
    {{ utils.getControlledVocabularyTermYNU(reply) }}
    {%- set answer = utils.global_ns.var_stack.pop()  -%}

    {%- set elsi_names = globals.global_ns.dataset_vars.elsi_names -%}
    {%- for name in elsi_names -%}
      {{ utils.getDatasetsFromNames(globals, dmp_being_built, [name]) }}
      {%- set datasets = utils.global_ns.var_stack.pop()  -%}
      {%- for dataset in datasets -%}
        {%- do dataset.update({ "sensitive_data" : answer }) -%}
      {%- endfor -%}
    {%- endfor -%}
  {%- endif -%}
{%- endmacro -%}



{%- macro processEthicalIssues(globals, dmp_being_built, reply)  -%}
  {#- this answer is not per dataset, but for the dmp -#}
  {#- since today we always answer no, this is not an issue -#}
  {#- (as in our current KM, we can give EthicalIssues answers -#}
  {#- for each dataset -#}
  {#- .... how to solve this????: change ELSI question label -#}

  {{ utils.getControlledVocabularyTermYNU(reply) }}
  {%- set answer = utils.global_ns.var_stack.pop()  -%}
  {%- do dmp_being_built.update({ "ethical_issues_exist" : answer }) -%}
{%- endmacro -%}

